<template>
  <q-no-ssr>
    <q-layout view="hHh LpR fFf">
      <q-header elevated class="bg-primary text-white">
        <q-toolbar>
          <q-btn dense flat round icon="menu" @click="toggleLeftDrawer" />

          <q-toolbar-title> Dashboard </q-toolbar-title>

          <q-btn class="bg-black" @click="logout">logout</q-btn>
        </q-toolbar>
      </q-header>

      <q-drawer show-if-above v-model="leftDrawerOpen" side="left" bordered>
        <q-list>
          <q-item>
            <q-item-section>
              <q-item-label>{{ admin.username }}</q-item-label>
              <q-item-label caption>{{ admin.role }}</q-item-label>
            </q-item-section>
          </q-item>
          <q-item
            v-for="route in routes"
            :key="route.name"
            clickable
            v-ripple
            :to="route.path"
          >
            <q-item-section avatar>
              <q-icon :name="route.icon"></q-icon>
            </q-item-section>
            <q-item-section>{{ route.name }}</q-item-section>
          </q-item>
        </q-list>
      </q-drawer>

      <q-page-container>
        <router-view />
      </q-page-container>
    </q-layout>
  </q-no-ssr>
</template>

<script lang="ts">
import { LocalStorage } from 'quasar';
import { localAPI } from 'src/boot/axios';
import { useAdminStore } from 'src/stores/admin';
import { ref } from 'vue';

export default {
  name: 'AdminLayout',

  setup() {
    const routes = [
      {
        name: 'Dashboard',
        icon: 'home',
        path: '/admin/dashboard',
      },
      {
        name: 'User',
        icon: 'lock',
        path: '/admin/user',
      },
      {
        name: 'Post',
        icon: 'book',
        path: '/admin/blog',
      },
      {
        name: 'Category',
        icon: 'tag',
        path: '/admin/category',
      },
      {
        name: 'Tags',
        icon: 'tag',
        path: '/admin/tags',
      },
      {
        name: 'Game',
        icon: 'sports_esports',
        path: '/admin/game',
      },
      {
        name: 'Genre',
        icon: 'tag',
        path: '/admin/genres',
      },
    ];
    const admin = useAdminStore();
    const leftDrawerOpen = ref(false);
    return {
      routes,
      admin,
      leftDrawerOpen,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value;
      },
      async logout() {
        const token = LocalStorage.getItem('auth_token');
        LocalStorage.remove('auth_token');
        await localAPI.post(
          '/auth/logout',
          {},
          {
            headers: {
              auth_token: token,
            },
          }
        );
        window.location.href = '/login';
      },
    };
  },
  async beforeRouteEnter(_to, _prev, next) {
    const user = useAdminStore();
    const token = LocalStorage.getItem('auth_token');
    if (token) {
      try {
        const res = await localAPI.post(
          '/auth/login',
          {},
          {
            headers: {
              auth_token: token,
            },
          }
        );
        if (res.data.meta?.status === 'success') {
          const data = res.data.payload?.user;
          user.id = data?.id;
          user.username = data?.username;
          user.role = data?.role;
          next();
        } else {
          LocalStorage.remove('auth_token');
          next('/login');
        }
      } catch (err) {
        LocalStorage.remove('auth_token');
        next('/login');
      }
    } else {
      next('/login');
    }
  },
};
</script>
